//+------------------------------------------------------------------+
//|                                                         Plan.mq5 |
//|                                   Copyright 2019, Alain Verleyen |
//|                       https://www.mql5.com/en/users/angevoyageur |
//+------------------------------------------------------------------+
#property copyright "Copyright 2019, Alain Verleyen"
#property link      "https://www.mql5.com/en/users/angevoyageur"
#property version   "1.00"
//---
template<typename T>
class Container
  {
   T                 data[];
   int               size;
public:
                     Container(void) : size(0) { ArrayResize(data,size,100); };
                    ~Container(void)
     {
      //for(int i=0;i<size;i++)
      //  {
      //   if(CheckPointer(data[i])==POINTER_DYNAMIC)
      //      delete data[i];                            // DOESN'T COMPILE : 'data' - object pointer expected
      //  }                                              // Can be solved with a dynamic_cast, but need a super class
     };
   //---
   void Add(T value)             // DOESN'T COMPILE : 'POD' - objects are passed by reference only
     {                           // DOESN'T COMPILE : 'CObject' - objects are passed by reference only	Plan.mq5	26	13
      ArrayResize(data,size+1);
      data[size]=value;
      ++size;
     }

   //---
   T At(int i)
     {
      if(i<0 && i>=size)
        {
         //T ret={};                  // Can't be initialized ? => Warining : possible use of uninitialized variable 'ret'
         //return(ret);
         return(NULL);         // DOESN'T COMPILE with POD  : 'NULL' - parameter passed as reference, variable expected
        }
      return(data[i]);
     }
  };
//---
class CObject
  {
   int               aValue;
public:
                     CObject(void)                 { };
                     CObject(int v)                { SetValue(v); };
                     CObject(const CObject &obj)   { aValue=obj.GetValue(); };
                    ~CObject(void)                 { };
   void              SetValue(int v)               { aValue=v; };
   int               GetValue(void) const          { return(aValue); };
  };
//---
struct POD
  {
   int               value;
  };
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
   POD aPod={2};
   int a=11;
//---
   Container<int>intsBag;                 intsBag.Add(1); intsBag.Add(a);      Print("int : ",intsBag.At(0),intsBag.At(1));   // OK
   //Container<POD>podsBag;                 podsBag.Add(aPod);                                                                // DOESN'T COMPILE
   //Container<CObject>objectsBag;                                                                                            // DOESN'T COMPILE
   Container<CObject*>pointersBag;        pointersBag.Add(new CObject(4));     Print("ptr : ",pointersBag.At(0));             // OK

  }
//+------------------------------------------------------------------+
